/*
 * Copyright 2019 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/

/*! @brief Direction type  */
typedef enum _pin_mux_direction
{
    kPIN_MUX_DirectionInput = 0U,        /* Input direction */
    kPIN_MUX_DirectionOutput = 1U,       /* Output direction */
    kPIN_MUX_DirectionInputOrOutput = 2U /* Input or output direction */
} pin_mux_direction_t;

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_PULLUP 0x10u  /*!<@brief Selects pull-up function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name PIO1_2 (number 16), LD1[2]/CN1[29]/PIO1_2/CAPT_X3
  @{ */
#define BOARD_LED_RED_PERIPHERAL GPIO                       /*!<@brief Device name: GPIO */
#define BOARD_LED_RED_SIGNAL PIO1                           /*!<@brief GPIO signal: PIO1 */
#define BOARD_LED_RED_GPIO GPIO                             /*!<@brief GPIO device name: GPIO */
#define BOARD_LED_RED_GPIO_PIN 2U                           /*!<@brief PIO1 pin index: 2 */
#define BOARD_LED_RED_PORT 1U                               /*!<@brief PORT device name: 1U */
#define BOARD_LED_RED_PIN 2U                                /*!<@brief 1U pin index: 2 */
#define BOARD_LED_RED_CHANNEL 2                             /*!<@brief GPIO PIO1 channel: 2 */
#define BOARD_LED_RED_PIN_NAME PIO1_2                       /*!<@brief Pin name */
#define BOARD_LED_RED_LABEL "LD1[2]/CN1[29]/PIO1_2/CAPT_X3" /*!<@brief Label */
#define BOARD_LED_RED_NAME "LED_RED"                        /*!<@brief Identifier name */
#define BOARD_LED_RED_DIRECTION kPIN_MUX_DirectionOutput    /*!<@brief Direction */
                                                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void); /* Function assigned for the Cortex-M0P */

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
